use super::tests::parser;
use crate::data::prelude::*;
use crate::Parser;
use proptest::prelude::*;

proptest! {
    #[test]
    fn doesnt_crash_at_startup(s in "\\PC*") {
        if let Ok(instance) = parser(&s) {
            //instance.for_each(|_| {});
        }
    }
    #[test]
    fn test_parser(tokens: Vec<Token>) {
        if let Ok(instance) = Parser::new(tokens.into_iter(), false) {
            loop {
                let current = instance.peek_token();
                if current.is_none() {
                    break;
                }
                assert_eq!(current.cloned(), instance.next_token().map(|l| l.data));
            }
        }
    }
}
